package examples;

import java.nio.FloatBuffer;
import java.nio.IntBuffer;

import javax.media.opengl.GL;

public class VBORender1 {
  static final int numberOfBuffers = 4;
  static IntBuffer buffers = IntBuffer.allocate(numberOfBuffers);
  static int POSITION_OBJECT=0, COLOR_OBJECT = 1;
  static float PositionData[] =
  {
      -1.0f,0.0f,
      1.0f,0.0f,
      1.0f, 1.0f,
      1.0f, 1.0f,
      -1.0f, 1.0f,
      -1.0f, 0.0f,
  };
  static float PositionData2[] =
  {
      -1.0f,-1.0f,
      1.0f,-1.0f,
      1.0f, -0.5f,
      1.0f, -0.5f,
      -1.0f,-0.5f,
      -1.0f,-1.0f,
  };

  static float ColorData[] =
  {
      1,   0,   0,
      1, 1,   0,
      0, 1,   0,
      0, 1,   0,
      0,   0, 1,
      1,   0,   0
  };
  static float ColorData2[] =
  {
      1,   0,   0,
      1, 1,   0,
      0, 1,   0,
      0, 1,   0,
      0,   0, 1,
      1,   0,   0
  };
  static public void init(GL gl) {
    gl.glGenBuffers( numberOfBuffers,  buffers);

    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(COLOR_OBJECT));
    gl.glBufferData(GL.GL_ARRAY_BUFFER, ColorData.length*Integer.SIZE/8, FloatBuffer.wrap(ColorData), GL.GL_STATIC_DRAW);
    gl.glColorPointer(3, GL.GL_FLOAT, 0, 0);

    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(POSITION_OBJECT));
    gl.glBufferData(GL.GL_ARRAY_BUFFER, PositionData.length*Float.SIZE/8, FloatBuffer.wrap(PositionData), GL.GL_STATIC_DRAW);
    gl.glVertexPointer(2, GL.GL_FLOAT, 0, 0);

    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(COLOR_OBJECT+2));
    gl.glBufferData(GL.GL_ARRAY_BUFFER, ColorData.length*Integer.SIZE/8, FloatBuffer.wrap(ColorData), GL.GL_STATIC_DRAW);
    gl.glColorPointer(3, GL.GL_FLOAT, 0, 0);

    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(POSITION_OBJECT+2));
    gl.glBufferData(GL.GL_ARRAY_BUFFER, PositionData.length*Float.SIZE/8, FloatBuffer.wrap(PositionData2), GL.GL_STATIC_DRAW);
    gl.glVertexPointer(2, GL.GL_FLOAT, 0, 0);

    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, 0);
  }
  
  static public void display(GL gl) {

    gl.glEnableClientState(GL.GL_VERTEX_ARRAY);
    gl.glEnableClientState(GL.GL_COLOR_ARRAY);

    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(COLOR_OBJECT));
    gl.glColorPointer(3, GL.GL_FLOAT, 0, 0);
    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(POSITION_OBJECT));
    gl.glVertexPointer(2, GL.GL_FLOAT, 0, 0);

    gl.glDrawArrays(GL.GL_TRIANGLES, 0, PositionData.length);

    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(COLOR_OBJECT+2));
    gl.glColorPointer(3, GL.GL_FLOAT, 0, 0);
    gl.glBindBuffer(GL.GL_ARRAY_BUFFER, buffers.get(POSITION_OBJECT+2));
    gl.glVertexPointer(2, GL.GL_FLOAT, 0, 0);

    gl.glDrawArrays(GL.GL_TRIANGLES, 0, PositionData.length);

    gl.glDisableClientState(GL.GL_COLOR_ARRAY);
    gl.glDisableClientState(GL.GL_VERTEX_ARRAY); 
  }
}
