package mains;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.util.ArrayList;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.glu.GLU;

public class RendererOpenGL implements GLEventListener, KeyListener, MouseListener, 
                                       MouseMotionListener, MouseWheelListener {

  public void init(GLAutoDrawable gLDrawable) {
    GL gl = gLDrawable.getGL();
    gl.setSwapInterval(GL.GL_FALSE);
    gl.glShadeModel(GL.GL_SMOOTH);              // Enable Smooth Shading
    gl.glClearColor(0.5f, 0.99f, 0.2f, 1f);    // Black Background
    gl.glClearDepth(1.0f);                      // Depth Buffer Setup
    gl.glEnable(GL.GL_DEPTH_TEST);              // Enables Depth Testing
    gl.glDepthFunc(GL.GL_LEQUAL);               // The Type Of Depth Testing To Do
    gl.glHint(GL.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST); // Really Nice Perspective Calculations
    //      gl.glEnable(GL.GL_TEXTURE_2D);
    gl.glEnable(GL.GL_CULL_FACE);
    gl.glCullFace(GL.GL_BACK);
    gLDrawable.addKeyListener(this);
    gLDrawable.addMouseListener(this);
    gLDrawable.addMouseMotionListener(this);
    gLDrawable.addMouseWheelListener(this); 
    Main.canvas.setSize(Main.window.getSize());
    
    // now generate Displaylists for OpenGL-Drawing
    // draw a triangle
    examples.TestBlend.init(gl);
//    examples.TestSimple.init(gl);
  }
  float lookFromX = 0, lookFromY = 0, lookFromZ = 4;
//  static private float rotation = 0;
  public void display(GLAutoDrawable gLDrawable) {
    GL gl = gLDrawable.getGL();
    gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glLoadIdentity();   
    glu.gluLookAt( lookFromX, lookFromY, lookFromZ,   0,0,0, 0,1,0);
    // Now call the OpenGL-Displaylists

    examples.TestBlend.display(gl,time);
//    examples.TestSimple.display(gl,time);
    Timer();
  }
  public static GLU glu = new GLU();
  private static double perspectiveAngle=45, nearPlane=1, farPlane =20;
  public void reshape(GLAutoDrawable gLDrawable, int x, int y, int width, int height) {
    GL gl = gLDrawable.getGL();
    Main.canvas.setSize(Main.window.getSize());
    if (height <= 0) // avoid a divide by zero error!
      height = 1;
    float aspect = (float)width / (float)height;
    gl.glViewport(0, 0, width, height);
    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();
    glu.gluPerspective(perspectiveAngle, aspect, nearPlane, farPlane);
    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glLoadIdentity();
  }
  ///////////  Auxiliary functions
  public void displayChanged(GLAutoDrawable gLDrawable, boolean b2, boolean b1) { }
  private ArrayList<Integer> displayLists;
  public void addToDisplayLists(int name) {
    if(displayLists==null) displayLists = new ArrayList<Integer>();
    displayLists.add(name);
  }
  public void callDisplayLists(GL gl) {
    if(displayLists==null) return;
    for(int name : displayLists) gl.glCallList(name);
  }
  public float deltaTime = 0;
  public float time  = 0;
  private long startTimeNS = System.nanoTime();
  private long lastTimeNS = startTimeNS;
  private float lastTime = -1;
  private int frameCount = 0;
  public void Timer(){
    long nanoTime = System.nanoTime();
    time = ((float)(nanoTime-startTimeNS))/1000000000f;
    long deltaTimeNano = nanoTime-lastTimeNS;
    lastTimeNS = nanoTime;
    deltaTime = ((float)deltaTimeNano)/1000000000f;
    frameCount++;
    if(lastTime+1<=time) {
      lastTime = time;
      Main.window.setTitle((frameCount)+" frames per second at "+((int)time));
      frameCount = 0;
    }
  }
  ////////// KEY and MOUSE functions
  public void keyTyped(KeyEvent e) {

  }
  public void keyPressed(KeyEvent e) {

  }
  public void keyReleased(KeyEvent e) {

  }
  public void mousePressed(MouseEvent e) {
    mouseMotionStartX = e.getX();
    mouseMotionStartY = e.getY();
    mouseMotionStartKey = e.getButton();
  }
  // Mausinteraktivitaet
  private int mouseMotionStartX;
  private int mouseMotionStartY;
  @SuppressWarnings("unused")
  private int mouseMotionStartKey;

  public void mouseDragged(MouseEvent e) {
    switch(e.getButton()) {
      case MouseEvent.BUTTON2: // right mouse button pressed
        lookFromZ += (mouseMotionStartY - e.getY())*180d/5000;
        mouseMotionStartY = e.getY();
        break;
      case MouseEvent.BUTTON1: // left mouse button pressed
      case MouseEvent.BUTTON3: // right mouse button pressed
        lookFromX += (mouseMotionStartX - e.getX())*180d/5000;
        mouseMotionStartX =  e.getX();
        lookFromY -= (mouseMotionStartY -  e.getY())*180d/5000;
        mouseMotionStartY =  e.getY();
        break;
    } 

  }
  public void mouseEntered(MouseEvent e) {
    // NOP
  }

  public void mouseExited(MouseEvent e) {
    // NOP
  }

  public void mouseReleased(MouseEvent e) {
    // NOP
  }

  public void mouseClicked(MouseEvent e) {
    // NOP
  }
  public void mouseMoved(MouseEvent e) {

  }

  public void mouseWheelMoved(MouseWheelEvent e) {

  }


}
